AIO_SUSPEND(3)

NAME
aio_suspend - suspend until asynchronous I/O operations or timeout complete (REALTIME)

LIBRARY
librt

SYNOPSIS
#include <aio.h>
int
aio_suspend(const struct aiocb * const list[], int nent, const struct timespec * timeout);

DESCRIPTION
The aio_suspend() system call suspends the calling process until at least one of the specified asynchronous I/O requests have completed, a signal is delivered, or the struct timeout (see timespec(3)) has passed.

The list argument is an array of nent pointers to asynchronous I/O requests. Array members containing NULL pointers will be silently ignored.

If timeout is not a NULL pointer, it specifies a maximum interval to suspend. If timeout is a NULL pointer, the suspend blocks indefinitely. To effect a poll, the timeout should point to a zero-value timespec structure.

RETURN VALUES
If one or more of the specified asynchronous I/O requests have completed, aio_suspend() returns 0. Otherwise it returns -1 and sets errno to indicate the error, as enumerated below.

ERRORS
The aio_suspend() system call will fail if:

[EAGAIN]
    The timeout expired before any I/O requests completed.

[EINTR]
    The suspend was interrupted by a signal.

[EINVAL]
    The list argument contains more than AIO_LISTIO_MAX asynchronous I/O requests, or at least one of the requests is not valid.

SEE ALSO
aio(3), timespec(3)

STANDARDS
The aio_suspend() system call is expected to conform to the p1003.1-2001 standard.

HISTORY
The aio_suspend() system call first appeared in NetBSD 5.0.